﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=9.01
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
#End Region

Sub Process_Globals
	
	Dim Provider 		As FileProvider
	Dim nativeMe 		As JavaObject
	Dim n2				As Notification
	Dim n2ID			As Int = 16
	
End Sub

Sub Service_Create
	
	Service.AutomaticForegroundMode = Service.AUTOMATIC_FOREGROUND_NEVER
	n2.Initialize
	nativeMe.InitializeContext
	Provider.Initialize
	
End Sub

Sub Service_Start (StartingIntent As Intent)
	
	Service.StartForeground(n2ID,CreateNotification("App Updater Example","New Application Download","ic_cloud_download_white_24dp",Main,False,False))
	download_newapk
	
End Sub

Sub Service_Destroy
	
	n2.Cancel(n2ID)
	Service.StopForeground(n2ID)
	
End Sub



Sub download_newapk
	
	Dim job_newAPP As HttpJob
	
	job_newAPP.Initialize("job_newAPP",Me)
	job_newAPP.Download(Main.newApp.appLink)
	Wait for (job_newAPP) JobDone (job_newAPP As HttpJob)
	
	If job_newAPP.Success = True Then
		' // delete existing file
		If File.Exists(Provider.SharedFolder,"newapp.apk") Then
			File.Delete(Provider.SharedFolder,"newapp.apk")
		End If
		' // save new file
		Dim outNewAPK As OutputStream = File.OpenOutput(Provider.SharedFolder,"newapp.apk", False)
		File.Copy2(job_newAPP.GetInputStream, outNewAPK)
		outNewAPK.Close
	End If
	job_newAPP.Release
	
	' // install the app	
	Dim in As Intent
	in.Initialize(in.ACTION_VIEW,"" )
	Provider.SetFileUriAsIntentData(in, "newapp.apk")
	' // Type must be set after calling SetFileUriAsIntentData
	in.SetType("application/vnd.android.package-archive")
	StartActivity(in)
	
	StopService(Me)
	
End Sub

Private Sub CreateNotification(Title As String, Content As String, Icon As String, TargetActivity As Object, Sound As Boolean, Vibrate As Boolean) As Notification
	
	Dim p As Phone
	
	If p.SdkVersion >= 26 Then
		Dim nb As NotificationBuilder
		Dim Channel As NotificationChannelBuilder 'New object
		Dim ChannelID As String = "ies_app_updater_new_app"
		Dim ChannelName As String = "App Updater New App Download"
        
		'Build a Channel
    
		If Channel.ChannelsSupported Then
			Channel.Initialize(ChannelID, ChannelName, Channel.IMPORTANCE_LOW)
			Channel.Build
		End If
		
		nb.Initialize(ChannelID)
		nb.OnGoingEvent = True
		nb.DefaultSound = Sound
		nb.DefaultVibrate = Vibrate
		nb.DefaultLight = False
		nb.ContentTitle = Title
		nb.ContentText = Content
		nb.setActivity(TargetActivity)
		nb.SmallIcon = Icon
		' //set the return object for the notification object (n1) in this service
		n2 = nb.GetNotification
		
		Return  n2 'nb.GetNotification

	Else
		n2.Initialize
		n2.Light = False
		n2.Vibrate = False
		n2.Sound = False
		n2.OnGoingEvent = True
		n2.Icon = Icon
		n2.SetInfo(Title, Content, TargetActivity)
		
		Return n2
	End If
End Sub