﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=9.01
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
	
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	
	Public lnk As String = "http://mydomain.com/Public/myappname.ver"
	
	' // contents of ver file, each field is seperated by a tab
	' Field 0 = 2.226.19.09.19.01a	
	' Field 1 = A new version of the My APP Is available, Download And Update Now ?
	' Field 2 = My App Is up To date
	' Field 3 = http://www.mydomain.com/Public/myapp.apk
	
	
	
	Public nNewApp As Notification
	Public nNewAppnID As Int = 51050
	
	
End Sub

Sub Service_Create

	Log("svc_app_update(), Service_Create")

End Sub

Sub Service_Start (StartingIntent As Intent)
	
	Log("svc_app_update(), Service_Start")
	
	Wait For (Download(Me, lnk)) JobDone (j As HttpJob)
	If j.Success Then
		
		Try 
			Dim app() As String = Regex.Split(Chr(9),j.GetString)
				
			' // set the data
			Main.newApp.appLink = app(3)
			Main.newApp.appNew = app(1)
			Main.newApp.appOK = app(2)
			Main.newApp.version = app(0)
			
			' // app version check
			If Main.newApp.version = Main.version  Then
				Main.newApp.nonewAPP = True
			End If
			If Main.newApp.version <> Main.version  Then
				Main.newApp.newAPP = True
				CreateNotification2("New App Available","Click for download options","ic_file_download_white_24dp",NewAppAvailable,True,True,nNewApp,nNewAppnID)
			End If
		Catch
			Log("svc_app_update(), Job Failed, error  " & LastException.Message)
		End Try		
			
		
	Else
		Log("svc_app_update(), Job Failed " & lnk)
	End If
	j.Release

	StopService(Me)

End Sub

Sub Download (Callback As Object, link As String) As HttpJob
    
	Dim j As HttpJob
	j.Initialize("", Callback)
	j.Download(link)
	Return j
	
End Sub



Private Sub CreateNotification2(Title As String, Content As String, Icon As String, TargetActivity As Object, _
									Sound As Boolean, Vibrate As Boolean, pN As Notification,pNID As Int) As Notification
	
	'mod_functions.writelog("svc_service(), CreateNotification - " & Content)
	
	Dim p As Phone
	
	
	If p.SdkVersion >= 21 Then
		Dim nb As NotificationBuilder
		Dim Channel As NotificationChannelBuilder
		Dim ChannelID As String = "ies_app_updater"
		Dim ChannelName As String = "App Updater"
        
		' // Build a Channel
    
		If Channel.ChannelsSupported Then
			Channel.Initialize(ChannelID, ChannelName, Channel.IMPORTANCE_LOW)
			Channel.Build
		End If
		
		nb.Initialize(ChannelID)
		nb.AutoCancel = True
		nb.OnGoingEvent = False
		nb.DefaultSound = Sound
		nb.DefaultVibrate =Vibrate
		nb.DefaultLight = False
		nb.ContentTitle = Title
		nb.ContentText = Content
		nb.setActivity(TargetActivity)
		nb.SmallIcon = Icon
		nb.Number = pNID
		' //set the return object for the notification object (n1) in this service
		pN = nb.GetNotification
	Else
		pN.Initialize
		pN.Number = pNID
		pN.Light = False
		pN.Vibrate = False
		pN.Sound = False
		pN.OnGoingEvent = True
		pN.Icon = Icon
		pN.SetInfo(Title, Content, TargetActivity)
	End If
	pN.Notify(pNID)
	Return pN
	
End Sub

Sub Service_Destroy

	Log("svc_app_update(), Service_Destroy")

End Sub
