﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=9.01
@EndOfDesignText@
#Region  Activity Attributes 
	
	#FullScreen: False
	#IncludeTitle: False

#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Private Theme_Value As Int
	
End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
	Private res As XmlLayoutBuilder
	
End Sub

Sub Activity_Create(FirstTime As Boolean)
	'Do not forget to load the layout file created with the visual designer. For example:
	Activity.Color = Colors.Transparent
	
	If FirstTime Then
		SetTheme(res.GetResourceId("style", "android:style/Theme.Material.Light"))
	End If
	
	
End Sub

Sub Activity_Resume
	
	Try 
		Do While Not(CanRequestPackageInstalls)
			
			MsgboxAsync("Please allow MY APP to install updates", "Install Updates")
			Wait For Msgbox_Result(Result As Int)
			Dim in As Intent
			in.Initialize("android.settings.MANAGE_UNKNOWN_APP_SOURCES", "package:" & Application.PackageName)
			StartActivity(in)
		
		Loop
	Catch
		Log("NewAppAvailable() error - " & LastException.Message)
	End Try

	offer_update
	
End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub


Private Sub SetTheme (Theme As Int)
	If Theme = 0 Then
		ToastMessageShow("Theme not available.", False)
		Return
	End If
	If Theme = Theme_Value Then Return
	File.WriteString(File.DirInternal, "theme.txt", Theme)
	Theme_Value = Theme
	Activity.Finish
	StartActivity(Me)
End Sub


#if java
import anywheresoftware.b4a.objects.streams.*;
public void _onCreate() {
	try {
	if (File.Exists(getFilesDir().toString(), "theme.txt"))
		_theme_value = Integer.parseInt(File.ReadString(getFilesDir().toString(), "theme.txt"));
	} catch (Exception e) {
		throw new RuntimeException(e);
	}
	if (_theme_value != 0)
		setTheme(_theme_value);
}
#end if

Sub CanRequestPackageInstalls As Boolean
	
	' // https://www.b4x.com/android/forum/threads/version-safe-apk-installation.87667/#content
	Dim ctxt As JavaObject
	ctxt.InitializeContext
	Dim PackageManager As JavaObject = ctxt.RunMethod("getPackageManager", Null)
	Return PackageManager.RunMethod("canRequestPackageInstalls", Null)
	
End Sub

Sub offer_update
	
	If Msgbox2(Main.newApp.appNew,"New Application","Yes","","No",Null) = DialogResponse.Positive Then
		StartService(DownloadService)
	End If
	
	StartActivity(Main)
	Activity.Finish
	
End Sub